uk.ac.starlink.table.storage

## Class ColumnStoreStarTable

- java.lang.Object
- - uk.ac.starlink.table.WrapperStarTable
  - - uk.ac.starlink.table.storage.ColumnStoreStarTable

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, StarTable

      public class ColumnStoreStarTable
      extends WrapperStarTable

  StarTable implementation which retrieves its data from `ColumnStore` objects.
  Since:
    21 Jun 2006

- - ### Field Summary

    - ### Fields inherited from class uk.ac.starlink.table.WrapperStarTable

      `baseTable`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ColumnStoreStarTable(StarTable template, long nrow, ColumnStore[] colStores)` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `getCell(long lrow, int icol)` Returns the contents of a given table cell.
    `java.lang.Object[]` | `getRow(long lrow)` Returns the contents of a given table row.
    `RowAccess` | `getRowAccess()` Returns an object which can provide random access to this table's data, if random access is implemented.
    `long` | `getRowCount()` Returns the number of rows in this table, if known.
    `RowSequence` | `getRowSequence()` Returns an object which can iterate over all the rows in the table sequentially.
    `RowSplittable` | `getRowSplittable()` Returns an object which can iterate over all the rows in the table, but which may also be requested to split recursively for potentially parallel processing.
    `boolean` | `isRandom()` Indicates whether random access is provided by this table.

    - ### Methods inherited from class uk.ac.starlink.table.WrapperStarTable

      `checkedLongToInt, close, getBaseTable, getColumnAuxDataInfos, getColumnCount, getColumnInfo, getName, getParameterByName, getParameters, getURL, setName, setParameter, setURL, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ColumnStoreStarTable

          public ColumnStoreStarTable(StarTable template,
                                      long nrow,
                                      ColumnStore[] colStores)

      Constructor.
      Parameters:
        `template` - template table supplying metadata
        `nrow` - number of rows in this table
        `colStores` - array of ColumnStore objects, one for each column in the table

  - ### Method Detail

    - #### isRandom

          public boolean isRandom()

      Description copied from interface: `StarTable`
      Indicates whether random access is provided by this table. Only if the result is `true` may the `StarTable.getRowAccess()`, `StarTable.getRow(long)` and `StarTable.getCell(long, int)` methods be used.
      Specified by:
        `isRandom` in interface `StarTable`
      Overrides:
        `isRandom` in class `WrapperStarTable`
      Returns:
        `true` if table random access methods are available

    - #### getRowCount

          public long getRowCount()

      Description copied from interface: `StarTable`
      Returns the number of rows in this table, if known. If the number of rows cannot be (easily) determined, a value of -1 will be returned.
      Specified by:
        `getRowCount` in interface `StarTable`
      Overrides:
        `getRowCount` in class `WrapperStarTable`
      Returns:
        the number of rows, or -1

    - #### getCell

          public java.lang.Object getCell(long lrow,
                                          int icol)
                                   throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns the contents of a given table cell. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`.

      This method is safe for concurrent use from multiple threads, but in general it is recommended to use a `RowAccess` instead.

      Specified by:
        `getCell` in interface `StarTable`
      Overrides:
        `getCell` in class `WrapperStarTable`
      Parameters:
        `lrow` - the index of the cell's row
        `icol` - the index of the cell's column
      Returns:
        the contents of this cell
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### getRow

          public java.lang.Object[] getRow(long lrow)
                                    throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns the contents of a given table row. The returned value is equivalent to an array formed of all the objects returned by `getCell(irow,icol)` for all the columns `icol` in sequence.

      This method is safe for concurrent use from multiple threads, but in general it is recommended to use a `RowAccess` instead.

      Specified by:
        `getRow` in interface `StarTable`
      Overrides:
        `getRow` in class `WrapperStarTable`
      Parameters:
        `lrow` - the index of the row to retrieve
      Returns:
        an array of the objects in each cell in row `irow`
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### getRowSequence

          public RowSequence getRowSequence()
                                     throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns an object which can iterate over all the rows in the table sequentially. Each such returned object is safe for use within a single thread, but not in general from multiple threads concurrently.
      Specified by:
        `getRowSequence` in interface `StarTable`
      Overrides:
        `getRowSequence` in class `WrapperStarTable`
      Returns:
        new RowSequence
      Throws:
        `java.io.IOException` - if there is an error providing access

    - #### getRowSplittable

          public RowSplittable getRowSplittable()
                                         throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns an object which can iterate over all the rows in the table, but which may also be requested to split recursively for potentially parallel processing.

      The return value must be non-null, and may provide splitting arrangements specially appropriate for the implementation. If this table 'wraps' an upstream table, it is usually best to base the implementation on calls to the the upstream `getRowSplittable` method, so that upstream policy about how to divide up the table is respected. However, implementations without special requirements may return `Tables.getDefaultRowSplittable``(this)`.

      Specified by:
        `getRowSplittable` in interface `StarTable`
      Overrides:
        `getRowSplittable` in class `WrapperStarTable`
      Returns:
        new RowSplittable
      Throws:
        `java.io.IOException`
      See Also:
        `RowRunner`

    - #### getRowAccess

          public RowAccess getRowAccess()
                                 throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns an object which can provide random access to this table's data, if random access is implemented. Each such returned object is safe for use within a single thread, but not in general from multiple threads concurrently.
      Specified by:
        `getRowAccess` in interface `StarTable`
      Overrides:
        `getRowAccess` in class `WrapperStarTable`
      Returns:
        new RowAccess
      Throws:
        `java.io.IOException` - if there is an error setting up access